/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_DNS
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_dns.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 22
bi_primitive_hostname(eval_environ_t env)
#line 22

#line 22 "bi_dns.m4"
{
#line 22
	
#line 22

#line 22

#line 22
char * string;
#line 22
        
#line 22
get_string_arg(env, 0, &string);
#line 22
        
#line 22

#line 22
        adjust_stack(env, 1);
#line 22

#line 22
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 22
		prog_trace(env, "primitive_hostname %s",string);;
#line 22

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 28
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("Cannot resolve IP %s"),string)
#line 31
;
	
	pushs(env, hbuf);
	free(hbuf);
}
}

void
#line 38
bi_primitive_resolve(eval_environ_t env)
#line 38

#line 38 "bi_dns.m4"
{
#line 38
	
#line 38

#line 38
long __bi_argcnt;
#line 38
char * string;
#line 38
        char * domain;
#line 38
        
#line 38
get_string_arg(env, 1, &string);
#line 38
        get_string_arg(env, 2, &domain);
#line 38
        
#line 38
get_numeric_arg(env, 0, &__bi_argcnt);
#line 38
        adjust_stack(env, __bi_argcnt + 1);
#line 38

#line 38
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 38
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 38

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 45
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("Cannot resolve %s.%s"),string,domain)
#line 47
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 50
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("Cannot resolve %s"),string)
#line 52
;
	}
	pushs(env, ipstr);
	free(ipstr);
}
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 71
bi_dns_getaddr(eval_environ_t env)
#line 71

#line 71 "bi_dns.m4"
{
#line 71
	
#line 71

#line 71

#line 71
char * string;
#line 71
        
#line 71
get_string_arg(env, 0, &string);
#line 71
        
#line 71

#line 71
        adjust_stack(env, 1);
#line 71

#line 71
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 71
		prog_trace(env, "dns_getaddr %s",string);;
#line 71

{
	GACOPYZ_UINT32_T ipbuf[64]; /* FIXME: arbitrary limit */
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	dnstat = a_lookup(string, ipbuf, NELEMS(ipbuf), &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0; i < ipcount; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { int __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 92
do {
#line 92
  char *__s = q;
#line 92
  heap_obstack_grow(env, __s, strlen(__s));
#line 92
} while (0);
		}
		do { int __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 95
do {
#line 95
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 95
  return;
#line 95
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 98
return;
#line 98
} while (0);
	default:
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getaddr", _("Failed to get A record for %s"),string);
#line 102
	}
}
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 112
bi_dns_getname(eval_environ_t env)
#line 112

#line 112 "bi_dns.m4"
{
#line 112
	
#line 112

#line 112

#line 112
char * ipstr;
#line 112
        
#line 112
get_string_arg(env, 0, &ipstr);
#line 112
        
#line 112

#line 112
        adjust_stack(env, 1);
#line 112

#line 112
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 112
		prog_trace(env, "dns_getname %s",ipstr);;
#line 112

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char *names[64];

		if (!(inet_aton(ipstr, &addr)))
#line 119
			env_throw_bi(env, mfe_invip, "dns_getname", _("Invalid IP: %s"),ipstr)
#line 121
;

	dnstat = ptr_lookup(addr, names, NELEMS(names), &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i;
		size_t ncount;

		for (ncount = 0; ncount < NELEMS(names) && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		for (i = 0; i < ncount; i++) {
			if (i > 0)
				do { int __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 137
do {
#line 137
  char *__s = names[i];
#line 137
  heap_obstack_grow(env, __s, strlen(__s));
#line 137
} while (0);
		}
		do { int __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		for (; i < ncount; i++) 
			free(names[i]);

		
#line 144
do {
#line 144
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 144
  return;
#line 144
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 147
return;
#line 147
} while (0);
	default:
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getname", _("Failed to get PTR record for %s"),ipstr);
#line 151
	}
}
}

void
#line 155
bi_primitive_hasmx(eval_environ_t env)
#line 155

#line 155 "bi_dns.m4"
{
#line 155
	
#line 155

#line 155

#line 155
char * string;
#line 155
        
#line 155
get_string_arg(env, 0, &string);
#line 155
        
#line 155

#line 155
        adjust_stack(env, 1);
#line 155

#line 155
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 155
		prog_trace(env, "primitive_hasmx %s",string);;
#line 155

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 162
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("Cannot get MX records for %s"),string)
#line 165
;

	if (mxstat == mf_success) {
		dns_freemx(mxbuf);
		
#line 169
do {
#line 169
  push(env, (STKVAL) (1));
#line 169
  return;
#line 169
} while (0);
	}
	
#line 171
do {
#line 171
  push(env, (STKVAL) (0));
#line 171
  return;
#line 171
} while (0);
}
}

void
#line 175
bi_getmx(eval_environ_t env)
#line 175

#line 175 "bi_dns.m4"
{
#line 175
	
#line 175

#line 175
long __bi_argcnt;
#line 175
char * domain;
#line 175
        long  resolve;
#line 175
        
#line 175
get_string_arg(env, 1, &domain);
#line 175
        get_numeric_arg(env, 2, &resolve);
#line 175
        
#line 175
get_numeric_arg(env, 0, &__bi_argcnt);
#line 175
        adjust_stack(env, __bi_argcnt + 1);
#line 175

#line 175
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 175
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? resolve : 0));;
#line 175

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	if (((__bi_argcnt > 1) ? resolve : 0))
		mxstat = getmxip(domain, mxbuf);
	else
		mxstat = getmx(domain, mxbuf);
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 184
			env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("Cannot get MX records for %s"),domain)
#line 186
;
	if (mxstat == mf_not_found)
		do {pushs(env, "");
#line 188
return;
#line 188
} while (0);
	else {
		int i;
		
		heap_obstack_begin(env);
		for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
			if (i > 0)
				do { int __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 196
do {
#line 196
  char *__s = mxbuf[i];
#line 196
  heap_obstack_grow(env, __s, strlen(__s));
#line 196
} while (0);
		}
		do { int __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		dns_freemx(mxbuf);
		
#line 200
do {
#line 200
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 200
  return;
#line 200
} while (0);
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error(_("INTERNAL ERROR at %s:%d: resolve_hostname returned "
			   "invalid IP address: %s"),
			 __FILE__, __LINE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 232
bi_primitive_ismx(eval_environ_t env)
#line 232

#line 232 "bi_dns.m4"
{
#line 232
	
#line 232

#line 232

#line 232
char * domain;
#line 232
        char * ipstr;
#line 232
        
#line 232
get_string_arg(env, 0, &domain);
#line 232
        get_string_arg(env, 1, &ipstr);
#line 232
        
#line 232

#line 232
        adjust_stack(env, 2);
#line 232

#line 232
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 232
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 232

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
#line 240
			env_throw_bi(env, mfe_noresolve, "primitive_ismx", _("Cannot resolve host name %s"),ipstr)
;
	
	mxstat = getmx(domain, mxbuf);
	
		if (!(mxstat == mf_success))
#line 245
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_ismx", _("Cannot get MXs for %s"),domain)
#line 247
;

	for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
		unsigned long n;
		
		if (!resolve_host(mxbuf[i], &n) && n == ip) {
			rc = 1;
			break;
		}
	}
	dns_freemx(mxbuf);
	
#line 258
do {
#line 258
  push(env, (STKVAL) (rc));
#line 258
  return;
#line 258
} while (0);
}
}

void
#line 262
bi_relayed(eval_environ_t env)
#line 262

#line 262 "bi_dns.m4"
{
#line 262
	
#line 262

#line 262

#line 262
char * s;
#line 262
        
#line 262
get_string_arg(env, 0, &s);
#line 262
        
#line 262

#line 262
        adjust_stack(env, 1);
#line 262

#line 262
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 262
		prog_trace(env, "relayed %s",s);;
#line 262

{
	
#line 264
do {
#line 264
  push(env, (STKVAL) (relayed_domain_p(s)));
#line 264
  return;
#line 264
} while (0);
}
}

void
#line 268
bi_listens(eval_environ_t env)
#line 268

#line 268 "bi_dns.m4"
{
#line 268
	
#line 268

#line 268
long __bi_argcnt;
#line 268
char * s;
#line 268
        long  port;
#line 268
        
#line 268
get_string_arg(env, 1, &s);
#line 268
        get_numeric_arg(env, 2, &port);
#line 268
        
#line 268
get_numeric_arg(env, 0, &__bi_argcnt);
#line 268
        adjust_stack(env, __bi_argcnt + 1);
#line 268

#line 268
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 268
		prog_trace(env, "listens %s %lu",s, ((__bi_argcnt > 1) ? port : 0));;
#line 268

{
	
#line 270
do {
#line 270
  push(env, (STKVAL) (listens_on (s, ((__bi_argcnt > 1) ? port : 25)) == mf_success));
#line 270
  return;
#line 270
} while (0);
}
}

void
#line 274
bi_domainpart(eval_environ_t env)
#line 274

#line 274 "bi_dns.m4"
{
#line 274
	
#line 274

#line 274

#line 274
char * str;
#line 274
        
#line 274
get_string_arg(env, 0, &str);
#line 274
        
#line 274

#line 274
        adjust_stack(env, 1);
#line 274

#line 274
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 274
		prog_trace(env, "domainpart %s",str);;
#line 274

{
	char *p = strchr(str, '@');
	do {pushs(env, p ? p+1 : str);
#line 277
return;
#line 277
} while (0);
}
}

void
#line 281
bi_localpart(eval_environ_t env)
#line 281

#line 281 "bi_dns.m4"
{
#line 281
	
#line 281

#line 281

#line 281
char * str;
#line 281
        
#line 281
get_string_arg(env, 0, &str);
#line 281
        
#line 281

#line 281
        adjust_stack(env, 1);
#line 281

#line 281
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 281
		prog_trace(env, "localpart %s",str);;
#line 281

{
	char *p = strchr(str, '@');

	if (p) {
		size_t off;
		size_t size = p - str;
		char *string_space = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));
		memcpy(string_space, str, size);
		string_space[size] = 0;
		
#line 291
do {
#line 291
  push(env, (STKVAL) (off));
#line 291
  return;
#line 291
} while (0);
	} else
		do {pushs(env, str);
#line 293
return;
#line 293
} while (0);
}
}


#line 297
void
#line 297
dns_init_builtin()
#line 297
{
#line 297
	#line 22 "bi_dns.m4"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 38 "bi_dns.m4"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, 0, dtype_string, 2, 1, 0, dtype_string, dtype_string);
#line 71 "bi_dns.m4"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 112 "bi_dns.m4"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 155 "bi_dns.m4"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 175 "bi_dns.m4"
va_builtin_install_ex("getmx", bi_getmx, 0, 0, dtype_string, 2, 1, 0, dtype_string, dtype_number);
#line 232 "bi_dns.m4"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, 0, dtype_number, 2, 0, 0, dtype_string, dtype_string);
#line 262 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 268 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, dtype_number, 2, 1, 0, dtype_string, dtype_number);
#line 274 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 281 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, dtype_string, 1, 0, 0, dtype_string);

#line 297 "bi_dns.m4"
		
#line 297
}
#line 584 "../mfd/snarf.m4"

#line 584

